#include <allegro.h>
#include <math.h>
#include <iostream>

BITMAP *b;
int xp, yp, n, m;
const float PI=3.1415926535;
const int levelcount=3;
float x,y,d;
const int w=640, h=480;

int fogx;
int fogy;

int fogmoveticker;
const int fogslowness=100;

int curlevel=0;
int map[levelcount][10][10]=
{
{
{1,1,1,1,1,1,1,1,1},
{1,0,0,0,0,0,0,0,1},
{1,0,1,1,1,1,1,1,1},
{1,0,0,0,0,0,1,0,1},
{1,0,1,1,1,0,1,0,1},
{1,0,1,0,1,0,0,0,1},
{1,0,1,0,0,0,1,0,1},
{1,0,1,1,0,1,1,0,1},
{1,0,0,1,0,0,0,3,1},
{1,1,1,1,1,1,1,1,1}
},
{
{1,1,1,1,1,1,1,1,1},
{1,0,0,0,0,0,0,0,1},
{1,0,1,1,1,1,1,1,1},
{1,0,0,0,0,0,1,0,1},
{1,0,1,1,1,0,1,0,1},
{1,0,1,0,1,0,0,0,1},
{1,0,1,0,0,0,1,0,1},
{1,0,1,1,0,1,1,0,1},
{1,0,0,1,0,0,0,3,1},
{1,1,1,1,1,1,1,1,1}
},
{
{1,1,1,1,1,1,1,1,1},
{1,0,0,0,0,0,0,0,1},
{1,0,1,1,1,1,1,1,1},
{1,0,0,0,0,0,1,0,1},
{1,0,1,1,1,0,1,0,1},
{1,0,1,0,1,0,0,0,1},
{1,0,1,0,0,0,1,0,1},
{1,0,1,1,0,1,1,0,1},
{1,0,0,1,0,0,0,3,1},
{1,1,1,1,1,1,1,1,1}
}};

const int fogstarts[levelcount][2]={
{1,5},
{5,1},
{5,5},
};

void r(int x,int y,int s,int c,bool w){
	int col;
	if (w)
	{
		col=makecol(255,255,0);
		for (int i=0;i<10;i++)
			putpixel(b,x-20+rand()%(10)+10,0+rand()%(h),col);
	}
	else
	{
		col=makecol(255,255,255);
	
	for (int i=0;i<c/10;i++)
		putpixel(b,x-20+rand()%(10)+10,y-2+rand()%(s+10),col);
	}
}


void enemyr(int x,int y,int s,int c){
	int col=makecol(0,255,0);
	
	for (int i=0;i<c/10;i++)
		putpixel(b,x-1+rand()%(10+2),y-2+rand()%(s+10),col);
}

void initvariables()
{
	if (map[curlevel][fogx][fogy]==4)
		map[curlevel][fogx][fogy]=0;
	x=100;
	y=100;
	d=0;
	fogmoveticker=0;

	fogx=fogstarts[curlevel][0];
	fogy=fogstarts[curlevel][1];
	map[curlevel][fogx][fogy]=4;
}

void pl(){
	m=1;
	while(m>0){
		xp=1; yp=1;
		m=map[curlevel][xp][yp];
	}
//	map[curlevel][xp][yp]=3;
//	n++;

	if (map[curlevel][fogx][fogy]==4)
		map[curlevel][fogx][fogy]=0;
	
	curlevel++;
	initvariables();
}
void remove(int xa, int ya){
	map[curlevel][xa][ya]=0;
	pl();
}

void movefog()
{
	int c;
	map[curlevel][fogx][fogy]=0;
	//calculate possible directions
	int dircount=0;
	int dirarray[4];
	if (map[curlevel][fogx+1][fogy]==0)
	{
		dirarray[dircount]=1;
		dircount++;
	}
	if (map[curlevel][fogx-1][fogy]==0)
	{
		dirarray[dircount]=2;
		dircount++;
	}
	if (map[curlevel][fogx][fogy+1]==0)
	{
		dirarray[dircount]=3;
		dircount++;
	}
	if (map[curlevel][fogx][fogy-1]==0)
	{
		
		dirarray[dircount]=4;
		dircount++;		
	}
	
	std::cout<<dircount;
	int choice=dirarray[rand()%dircount];
	
	switch (choice)
	{
		case 1:fogx++;
			break;
		case 2:fogx--;
			break;
		case 3:fogy++;
			break;
		case 4:fogy--;
			break;
	}
	map[curlevel][fogx][fogy]=4;
	
}

int main(){
	allegro_init(); srand(time(0));
	install_keyboard();
	double u=0, c, t, s, q, f, g;
	initvariables();
	set_color_depth(32);
	set_gfx_mode(2, w, h, 0, 0);
	b=create_bitmap(w, h);
	n=-1; pl();
	
	while(!key[KEY_ESC]&&u==0){
		fogmoveticker=(fogmoveticker+1)%fogslowness;
		if (fogmoveticker==0)
			movefog();
		acquire_bitmap(b); clear_bitmap(b);
//		rectfill(b,0,240,640,480,makecol(32,32,32));
		//ray cast!
		for(double i=0; i<64; i++){//1.117; i+=0.0174){
			c=0; t=x; s=y;
			while(map[curlevel][int(t/100)][int(s/100)]!=1){
				c++; q=d+(i*0.0174)-0.5585+((float)(rand()%100))/2000;
				t+=sin(q); s+=cos(q);
				if (map[curlevel][int(t/100)][int(s/100)]==3)
				{
					int d=(10000/c)/cos(i*0.014);
					r(i*10,240-d,2*d,d,1);
				}
				else if (map[curlevel][int(t/100)][int(s/100)]==4)
				{
					int d=(10000/c)/cos(i*0.014);
					enemyr(i*10,240-d,2*d,d);
				}
			}
			//C now contains a number proportionate to the distance of the wall from the player
			c=(10000/c)/cos(i*0.014);
			r(i*10,240-c,2*c,c,(map[curlevel][int(t/100)][int(s/100)]==3?1:0));
		}
		
//		for(int i=0; i<n; i++){
//			r(5+(i*15),465,10,makecol(255,0,0),1);
//		}
		
		blit(b, screen, 0, 0, 0, 0, w, h);
		release_bitmap(b);
		vsync();
		
		f=x;g=y;
		if(key[84]){x+=sin(d)*10;y+=cos(d)*10;}if(key[82]) d-=0.125; 
		if(key[85]){x-=sin(d)*10;y-=cos(d)*10;}if(key[83]) d+=0.125;
		//if(key[26]) f=1; else f=0;
		
		c=map[curlevel][int(x/100)][int(y/100)];
		if(c!=0){
			x=f;y=g;
			if(c==3)
			{
				initvariables();//remove(x/100,y/100);
			}

//
			else if (c==4)
			{
				if (curlevel<(3-1))
				{
					curlevel++;
					initvariables();//die!
				}
			}
		}
	//	if(n>=20)u=1;
		
	}
    
	return 0;
}END_OF_MAIN()
